/////////////////////////////////////////////////////////////////////////
//Jeder Core übernimmt die Berechnung eines waagrechten Bildabschnitts.
//Ist die Bildhöhe beispielsweise 800 Pixel und der Prozessor hat 16 Core
//dann bleibt für jeden Core ein Höhe von 50 Pixeln zu berechnen.
//Es kommt mitunter zu einigen wenigen unvorhersehbaren Pixelfehlern
////////////////////////////////////////////////////////////////////////
class MyThread extends Thread {
  
  double D = 0.00000001; //kein Problem bei double-Rechnungen
  double xmin,ymin;
  double wh;
  color farbe;
  PGraphics pg;
  int n;
  int Z; //ab hier wird registriert
  double KF; //Störungsfaktor
  int j;
  int tN;
  boolean running = false;
  
//////////////////////////////////////////////////////////  
// Threads anlegen und Parameter übergeben
//////////////////////////////////////////////////////////// 
  
  public MyThread(double px0, double py0, int pmaxiterations,  double pwh, int nummer, double K) {  
    wh = pwh;
    tN = nummer;  
    KF =K;
    xmin=px0; ymin=py0; 
    n = pmaxiterations;   
    j=0;
    strokeWeight(1);
    colorMode(RGB,256,256,256);      
    pg = createGraphics(width,height/anzahlThreads);  
  }
/////////////////////////////////////////////////////////  

  public int gibNummer(){ //hilfreich bei eventueller Fehlersuche  
    return tN;   
  }
//////////////////////////////////////////////////////////////
  
  public void run() {
    this.running = true;
    tN =this.gibNummer();
    pg.beginDraw();
      pg.loadPixels();
        double xmax = xmin + anzahlThreads*wh;      
        double ymax = ymin + wh;
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);     
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {   
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            farbe = iteriere(x, y);
            pg.pixels[i+j*pg.width] = farbe;            
            x += dx;
          }
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false; 
  }  
/////////////////////////////////////////////////////////////////////

color iteriere(double xH, double yH){  
   color pixelFarbe;
   int i=0;
   double abstandAlt=0; 
   double abstandNeu =0;
   double lambda =0;
   double xAlt, yAlt, xNeu, yNeu; //Parameter für Iteration Punkt 1
   double xAlt1,yAlt1,xNeu1,yNeu1;   
   xAlt = xH; xAlt1 = xH + D;
   yAlt = yH; yAlt1 = yH ;   
 
  while(i <=n){     
     yNeu = (yAlt + K*Math.sin(2*Math.PI*xAlt)/(2*Math.PI));
     xNeu = (xAlt + yNeu);            
     yNeu1 = (yAlt1 + K*Math.sin(2*Math.PI*xAlt1)/(2*Math.PI));
     xNeu1 = (xAlt1 + yNeu1) ;        
     if(i >= Z){
       abstandNeu = sqrt(sq((float)(xNeu-xNeu1))+sq((float)(yNeu-yNeu1)));      
       if((abstandNeu-abstandAlt)/D !=0)
       lambda = lambda+Math.log(Math.abs(abstandNeu-abstandAlt)/D);
       abstandAlt = abstandNeu;
     } 
     xAlt = xNeu;
     yAlt = yNeu; 
     xAlt1 = xNeu1;
     yAlt1 = yNeu1; 
     i++; 
  }
  i=0;  
  lambda = lambda/(n-Z);//println(lambda);   
  pixelFarbe =faerben(lambda);    
  lambda =0;
  abstandAlt =0; abstandNeu =0;
  return    pixelFarbe;
}
////////////////////////////////////////////////////////////////////
 color faerben(double Lambda){
    float VZ ;
    if(Lambda < 0) VZ =-1;
    else VZ =1;
    float rot, gelb, blau, tuerkis;
    float faktorRot, faktorBlau, faktorGelb, faktorTuerkis;
    rot = 0; gelb =0; blau =0; tuerkis =0;
    faktorRot =150;
    faktorBlau= 30;
    faktorGelb = 30;
    faktorTuerkis = 150;
    if(Lambda > 7){
          rot = faktorRot*(float)Lambda;
          if(rot>255){
             gelb = (faktorGelb*(float)Lambda)-256;
             rot = 255;
          }else {
            gelb =0;
          } 
         farbe = color(rot,gelb,0); //Da "gelb" != 0 nur wenn rot =255 wirkt der grüne Farbton wie orange/gelb 
     }else if(Lambda <=7 && Lambda>0) {        
           blau = VZ*faktorBlau*VZ*(float)Lambda;
           farbe = color(0,0,255 -blau);
     }else if(Lambda <=0){ tuerkis =VZ* faktorTuerkis*(float)Lambda;
           farbe = color(0,tuerkis,255); //println(tuerkis);
     }else{
          farbe = color(255);
      }  
        
  return farbe;
 }
 
}
