//////////////////////////////////////////////////////////////////
//Standard-Map Lyapunov Fraktal mit Epsilon-Methode erstellt (Multithreaded)
/////////////////////////////////////////////////////////////////

ArrayList<MyThread> threads;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 
double xU = 0; double yU = 0  ;
double xO = 1; double yO = 1;
double wh = xO-xU;
double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
int n;//Anzahl der Iterationen
int Z;//Ab Z wird registiert
int nummerThread;//zur eventuellen Kontrolle
double K;

void setup() {
  
  threads = new  ArrayList<MyThread>(); 
  size(640, 640);
  strokeWeight(1); 
  background(0); 
  nummerThread  =0;
  K=  0.971635;//Parameter der Tschirikow-Tayler-Standardabbildung   
  n= 600;  //n...Anzahl der Iterationen  
  println("Anzahl Threads: "+anzahlThreads);//Info
  starteThreads(xU, yU, n, wh, nummerThread,K); 
}

/////////////////////////////////////////////////////////////////

void starteThreads(double px, double py, int pmaxiterations, double pwh, int nummer, double K){
  
  xU = px; yU = py;
  nummerThread = nummer;
  n = pmaxiterations ;
  wh = pwh;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <16){
        MyThread t = new MyThread(xU,y,n,wh/anzahlThreads, nummerThread,K);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(50);//zur Verringerung der Pixelfehler  
  }       
}
//////////////////////////////////////////////////////////////

void draw() {
  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 
  for(MyThread t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);
  }      
}

/////////////////////////////////////////////////////////////////
void mousePressed() { //damit man mit Linksklick den Fokus auf das Fenster 
   if (mouseButton == RIGHT){//setzen kann, ohne dabei zu zoomen.
      nummerThread =0;  //Damit die Threads wieder hochgezählt werden können     
      threads = new  ArrayList<MyThread>(); 
      xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
      xU = xUNeu; xO = xONeu; 
   
      yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
      yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
      yU =yUNeu; yO = yONeu; 
      wh = wh/5;
      starteThreads(xU, yU, n, wh, nummerThread,K);
      redraw();
   }
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
   if (key == '+'){ //Störung K vergrößern
    nummerThread =0;
    background(0);
    K = K + 0.05;
    println("Neuer Wert für K! K = "+K);
    threads = new  ArrayList<MyThread>(); 
    starteThreads(xU, yU, n, wh, nummerThread,K);
  }
  if (key == '-') {//Störung K verkleinern
     nummerThread =0;
     background(0);
     K = K - 0.05;
     println("Neuer Wert für K! K = "+K);
     threads = new  ArrayList<MyThread>(); 
     starteThreads(xU, yU, n, wh, nummerThread,K);  
  }
  if (key == 's') save("LyapunovSM.png");
  redraw();
 
}
/////////////////////////////////////////////////////////////////
